Remove unused variable and field
[official-gcc.git] / libgo / mksysinfo.sh
blob11bcb257a94a6118d7e1c52d9f5b84a957edcc68
1 #!/bin/sh
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
7 # Create sysinfo.go.
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This relies on a
11 # hook in gcc: the -fdump-go-spec option will generate debugging
12 # information in Go syntax.
14 # We currently #include all the files at once, which works, but leads
15 # to exposing some names which ideally should not be exposed, as they
16 # match grep patterns. E.g., WCHAR_MIN gets exposed because it starts
17 # with W, like the wait flags.
19 CC=${CC:-gcc}
20 OUT=tmp-sysinfo.go
22 set -e
24 rm -f sysinfo.c
25 cat > sysinfo.c <<EOF
26 #include "config.h"
28 #include <sys/types.h>
29 #include <dirent.h>
30 #include <errno.h>
31 #include <fcntl.h>
32 #include <netinet/in.h>
33 /* <netinet/tcp.h> needs u_char/u_short, but <sys/bsd_types> is only
34 included by <netinet/in.h> if _SGIAPI (i.e. _SGI_SOURCE
35 && !_XOPEN_SOURCE.
36 <sys/termios.h> only defines TIOCNOTTY if !_XOPEN_SOURCE, while
37 <sys/ttold.h> does so unconditionally. */
38 #ifdef __sgi__
39 #include <sys/bsd_types.h>
40 #include <sys/ttold.h>
41 #endif
42 #include <netinet/tcp.h>
43 #if defined(HAVE_NETINET_IN_SYSTM_H)
44 #include <netinet/in_systm.h>
45 #endif
46 #if defined(HAVE_NETINET_IP_H)
47 #include <netinet/ip.h>
48 #endif
49 #if defined(HAVE_NETINET_IP_MROUTE_H)
50 #include <netinet/ip_mroute.h>
51 #endif
52 #if defined(HAVE_NETINET_IF_ETHER_H)
53 #include <netinet/if_ether.h>
54 #endif
55 #include <signal.h>
56 #include <sys/ioctl.h>
57 #include <termios.h>
58 #if defined(HAVE_SYSCALL_H)
59 #include <syscall.h>
60 #endif
61 #if defined(HAVE_SYS_SYSCALL_H)
62 #include <sys/syscall.h>
63 #endif
64 #if defined(HAVE_SYS_EPOLL_H)
65 #include <sys/epoll.h>
66 #endif
67 #if defined(HAVE_SYS_FILE_H)
68 #include <sys/file.h>
69 #endif
70 #if defined(HAVE_SYS_MMAN_H)
71 #include <sys/mman.h>
72 #endif
73 #if defined(HAVE_SYS_PRCTL_H)
74 #include <sys/prctl.h>
75 #endif
76 #if defined(HAVE_SYS_PTRACE_H)
77 #include <sys/ptrace.h>
78 #endif
79 #include <sys/resource.h>
80 #include <sys/uio.h>
81 #include <sys/socket.h>
82 #include <sys/stat.h>
83 #include <sys/time.h>
84 #include <sys/times.h>
85 #include <sys/wait.h>
86 #include <sys/un.h>
87 #if defined(HAVE_SYS_USER_H)
88 #include <sys/user.h>
89 #endif
90 #if defined(HAVE_SYS_UTSNAME_H)
91 #include <sys/utsname.h>
92 #endif
93 #if defined(HAVE_SYS_SELECT_H)
94 #include <sys/select.h>
95 #endif
96 #include <time.h>
97 #include <unistd.h>
98 #include <netdb.h>
99 #include <pwd.h>
100 #if defined(HAVE_LINUX_FILTER_H)
101 #include <linux/filter.h>
102 #endif
103 #if defined(HAVE_LINUX_IF_ADDR_H)
104 #include <linux/if_addr.h>
105 #endif
106 #if defined(HAVE_LINUX_IF_ETHER_H)
107 #include <linux/if_ether.h>
108 #endif
109 #if defined(HAVE_LINUX_IF_TUN_H)
110 #include <linux/if_tun.h>
111 #endif
112 #if defined(HAVE_LINUX_NETLINK_H)
113 #include <linux/netlink.h>
114 #endif
115 #if defined(HAVE_LINUX_RTNETLINK_H)
116 #include <linux/rtnetlink.h>
117 #endif
118 #if defined(HAVE_NET_IF_H)
119 #include <net/if.h>
120 #endif
121 #if defined(HAVE_NET_IF_ARP_H)
122 #include <net/if_arp.h>
123 #endif
124 #if defined(HAVE_NET_ROUTE_H)
125 #include <net/route.h>
126 #endif
127 #if defined (HAVE_NETPACKET_PACKET_H)
128 #include <netpacket/packet.h>
129 #endif
130 #if defined(HAVE_SYS_MOUNT_H)
131 #include <sys/mount.h>
132 #endif
133 #if defined(HAVE_SYS_VFS_H)
134 #include <sys/vfs.h>
135 #endif
136 #if defined(HAVE_STATFS_H)
137 #include <sys/statfs.h>
138 #endif
139 #if defined(HAVE_SYS_TIMEX_H)
140 #include <sys/timex.h>
141 #endif
142 #if defined(HAVE_SYS_SYSINFO_H)
143 #include <sys/sysinfo.h>
144 #endif
145 #if defined(HAVE_USTAT_H)
146 #include <ustat.h>
147 #endif
148 #if defined(HAVE_UTIME_H)
149 #include <utime.h>
150 #endif
151 #if defined(HAVE_LINUX_ETHER_H)
152 #include <linux/ether.h>
153 #endif
154 #if defined(HAVE_LINUX_FS_H)
155 #include <linux/fs.h>
156 #endif
157 #if defined(HAVE_LINUX_REBOOT_H)
158 #include <linux/reboot.h>
159 #endif
160 #if defined(HAVE_SYS_INOTIFY_H)
161 #include <sys/inotify.h>
162 #endif
164 /* Constants that may only be defined as expressions on some systems,
165 expressions too complex for -fdump-go-spec to handle. These are
166 handled specially below. */
167 enum {
168 #ifdef TIOCGWINSZ
169 TIOCGWINSZ_val = TIOCGWINSZ,
170 #endif
171 #ifdef TIOCNOTTY
172 TIOCNOTTY_val = TIOCNOTTY,
173 #endif
174 #ifdef TIOCSCTTY
175 TIOCSCTTY_val = TIOCSCTTY,
176 #endif
180 ${CC} -fdump-go-spec=gen-sysinfo.go -std=gnu99 -S -o sysinfo.s sysinfo.c
182 echo 'package syscall' > ${OUT}
183 echo 'import "unsafe"' >> ${OUT}
184 echo 'type _ unsafe.Pointer' >> ${OUT}
186 # Get all the consts and types, skipping ones which could not be
187 # represented in Go and ones which we need to rewrite. We also skip
188 # function declarations, as we don't need them here. All the symbols
189 # will all have a leading underscore.
190 grep -v '^// ' gen-sysinfo.go | \
191 grep -v '^func' | \
192 grep -v '^type _timeval ' | \
193 grep -v '^type _timespec_t ' | \
194 grep -v '^type _timespec ' | \
195 grep -v '^type _timestruc_t ' | \
196 grep -v '^type _epoll_' | \
197 grep -v 'in6_addr' | \
198 grep -v 'sockaddr_in6' | \
199 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
200 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
201 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
202 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
203 >> ${OUT}
205 # The errno constants. These get type Errno.
206 echo '#include <errno.h>' | ${CC} -x c - -E -dM | \
207 egrep '#define E[A-Z0-9_]+ ' | \
208 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
210 # The O_xxx flags.
211 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
212 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
213 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
214 echo "const O_ASYNC = 0" >> ${OUT}
216 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
217 echo "const O_CLOEXEC = 0" >> ${OUT}
220 # These flags can be lost on i386 GNU/Linux when using
221 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
222 # before we see the definition of F_SETLK64.
223 for flag in F_GETLK F_SETLK F_SETLKW; do
224 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
225 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
226 echo "const ${flag} = ${flag}64" >> ${OUT}
228 done
230 # The signal numbers.
231 grep '^const _SIG[^_]' gen-sysinfo.go | \
232 grep -v '^const _SIGEV_' | \
233 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
234 if ! grep '^const SIGPOLL ' ${OUT} >/dev/null 2>&1; then
235 if grep '^const SIGIO ' ${OUT} > /dev/null 2>&1; then
236 echo "const SIGPOLL = SIGIO" >> ${OUT}
239 if ! grep '^const SIGCLD ' ${OUT} >/dev/null 2>&1; then
240 if grep '^const SIGCHLD ' ${OUT} >/dev/null 2>&1; then
241 echo "const SIGCLD = SIGCHLD" >> ${OUT}
245 # The syscall numbers. We force the names to upper case.
246 grep '^const _SYS_' gen-sysinfo.go | \
247 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
248 while read sys; do
249 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
250 echo "const $sup = _$sys" >> ${OUT}
251 done
253 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
254 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
255 echo "const SYS_GETDENTS = 0" >> ${OUT}
257 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
258 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
261 # Stat constants.
262 grep '^const _S_' gen-sysinfo.go | \
263 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
265 # Mmap constants.
266 grep '^const _PROT_' gen-sysinfo.go | \
267 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
268 grep '^const _MAP_' gen-sysinfo.go | \
269 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
270 grep '^const _MADV_' gen-sysinfo.go | \
271 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
272 grep '^const _MCL_' gen-sysinfo.go | \
273 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
275 # Process status constants.
276 grep '^const _W' gen-sysinfo.go |
277 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
278 # WSTOPPED was introduced in glibc 2.3.4.
279 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
280 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
281 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
282 else
283 echo 'const WSTOPPED = 2' >> ${OUT}
286 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
287 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
288 echo 'const WALL = ___WALL' >> ${OUT}
291 # Networking constants.
292 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
293 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
294 grep '^const _SOMAXCONN' gen-sysinfo.go |
295 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
296 >> ${OUT}
297 grep '^const _SHUT_' gen-sysinfo.go |
298 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
300 # The net package requires some const definitions.
301 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
302 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
303 echo "const $m = 0" >> ${OUT}
305 done
306 for m in SOCK_CLOEXEC SOCK_NONBLOCK; do
307 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
308 echo "const $m = -1" >> ${OUT}
310 done
312 # The syscall package requires AF_LOCAL.
313 if ! grep '^const AF_LOCAL ' ${OUT} >/dev/null 2>&1; then
314 if grep '^const AF_UNIX ' ${OUT} >/dev/null 2>&1; then
315 echo "const AF_LOCAL = AF_UNIX" >> ${OUT}
319 # pathconf constants.
320 grep '^const __PC' gen-sysinfo.go |
321 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
323 # The PATH_MAX constant.
324 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
325 echo 'const PathMax = _PATH_MAX' >> ${OUT}
328 # epoll constants.
329 grep '^const _EPOLL' gen-sysinfo.go |
330 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
331 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
332 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
333 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
335 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
336 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
339 # Prctl constants.
340 grep '^const _PR_' gen-sysinfo.go |
341 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
343 # Ptrace constants.
344 grep '^const _PTRACE' gen-sysinfo.go |
345 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
346 # We need some ptrace options that are not defined in older versions
347 # of glibc.
348 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
349 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
351 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
352 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
354 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
355 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
357 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
358 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
360 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
361 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
363 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
364 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
366 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
367 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
369 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
370 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
372 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
373 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
375 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
376 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
378 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
379 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
381 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
382 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
384 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
385 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
387 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
388 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
390 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
391 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
393 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
394 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
396 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
397 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
400 # The registers returned by PTRACE_GETREGS. This is probably
401 # GNU/Linux specific; it should do no harm if there is no
402 # _user_regs_struct.
403 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
404 if test "$regs" != ""; then
405 regs=`echo $regs | sed -e 's/type _user_regs_struct struct //' -e 's/[{}]//g'`
406 regs=`echo $regs | sed -e s'/^ *//'`
407 nregs=
408 while test -n "$regs"; do
409 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
410 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
411 # Capitalize the first character of the field.
412 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
413 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
414 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
415 field="$f$r"
416 nregs="$nregs $field;"
417 done
418 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
421 # Some basic types.
422 echo 'type Size_t _size_t' >> ${OUT}
423 echo "type Ssize_t _ssize_t" >> ${OUT}
424 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
425 echo "type Offset_t _off64_t" >> ${OUT}
426 else
427 echo "type Offset_t _off_t" >> ${OUT}
429 echo "type Mode_t _mode_t" >> ${OUT}
430 echo "type Pid_t _pid_t" >> ${OUT}
431 echo "type Uid_t _uid_t" >> ${OUT}
432 echo "type Gid_t _gid_t" >> ${OUT}
433 echo "type Socklen_t _socklen_t" >> ${OUT}
435 # The C int type.
436 sizeof_int=`grep '^const ___SIZEOF_INT__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
437 if test "$sizeof_int" = "4"; then
438 echo "type _C_int int32" >> ${OUT}
439 echo "type _C_uint uint32" >> ${OUT}
440 elif test "$sizeof_int" = "8"; then
441 echo "type _C_int int64" >> ${OUT}
442 echo "type _C_uint uint64" >> ${OUT}
443 else
444 echo 1>&2 "mksysinfo.sh: could not determine size of int (got $sizeof_int)"
445 exit 1
448 # The C long type, needed because that is the type that ptrace returns.
449 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
450 if test "$sizeof_long" = "4"; then
451 echo "type _C_long int32" >> ${OUT}
452 elif test "$sizeof_long" = "8"; then
453 echo "type _C_long int64" >> ${OUT}
454 else
455 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
456 exit 1
459 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
460 # double is commented by -fdump-go-spec.
461 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
462 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
464 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
465 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
468 # The time_t type.
469 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
470 echo 'type Time_t _time_t' >> ${OUT}
473 # The time structures need special handling: we need to name the
474 # types, so that we can cast integers to the right types when
475 # assigning to the structures.
476 timeval=`grep '^type _timeval ' gen-sysinfo.go`
477 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
478 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
479 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
480 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
481 echo $timeval | \
482 sed -e 's/type _timeval /type Timeval /' \
483 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
484 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
485 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
486 if test "$timespec" = ""; then
487 # IRIX 6.5 has __timespec instead.
488 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
490 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
491 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
492 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
493 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
494 echo $timespec | \
495 sed -e 's/^type ___timespec /type Timespec /' \
496 -e 's/^type _timespec /type Timespec /' \
497 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
498 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
500 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
501 if test "$timestruc" != ""; then
502 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
503 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
504 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
505 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
506 echo $timestruc | \
507 sed -e 's/^type _timestruc_t /type Timestruc /' \
508 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
509 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
512 # The tms struct.
513 grep '^type _tms ' gen-sysinfo.go | \
514 sed -e 's/type _tms/type Tms/' \
515 -e 's/tms_utime/Utime/' \
516 -e 's/tms_stime/Stime/' \
517 -e 's/tms_cutime/Cutime/' \
518 -e 's/tms_cstime/Cstime/' \
519 >> ${OUT}
521 # The stat type.
522 # Prefer largefile variant if available.
523 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
524 if test "$stat" != ""; then
525 grep '^type _stat64 ' gen-sysinfo.go
526 else
527 grep '^type _stat ' gen-sysinfo.go
528 fi | sed -e 's/type _stat64/type Stat_t/' \
529 -e 's/type _stat/type Stat_t/' \
530 -e 's/st_dev/Dev/' \
531 -e 's/st_ino/Ino/g' \
532 -e 's/st_nlink/Nlink/' \
533 -e 's/st_mode/Mode/' \
534 -e 's/st_uid/Uid/' \
535 -e 's/st_gid/Gid/' \
536 -e 's/st_rdev/Rdev/' \
537 -e 's/st_size/Size/' \
538 -e 's/st_blksize/Blksize/' \
539 -e 's/st_blocks/Blocks/' \
540 -e 's/st_atim/Atim/' \
541 -e 's/st_mtim/Mtim/' \
542 -e 's/st_ctim/Ctim/' \
543 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
544 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
545 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
546 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
547 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
548 >> ${OUT}
550 # The directory searching types.
551 # Prefer largefile variant if available.
552 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
553 if test "$dirent" != ""; then
554 grep '^type _dirent64 ' gen-sysinfo.go
555 else
556 grep '^type _dirent ' gen-sysinfo.go
557 fi | sed -e 's/type _dirent64/type Dirent/' \
558 -e 's/type _dirent/type Dirent/' \
559 -e 's/d_name \[0+1\]/d_name [0+256]/' \
560 -e 's/d_name/Name/' \
561 -e 's/]int8/]byte/' \
562 -e 's/d_ino/Ino/' \
563 -e 's/d_off/Off/' \
564 -e 's/d_reclen/Reclen/' \
565 -e 's/d_type/Type/' \
566 >> ${OUT}
567 echo "type DIR _DIR" >> ${OUT}
569 # Values for d_type field in dirent.
570 grep '^const _DT_' gen-sysinfo.go |
571 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
573 # The rusage struct.
574 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
575 if test "$rusage" != ""; then
576 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
577 rusage=`echo $rusage | sed -e 's/Godump_[0-9]* struct {\([^}]*\)};/\1/g'`
578 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
579 rusage=`echo $rusage | sed -e 's/^ *//'`
580 nrusage=
581 while test -n "$rusage"; do
582 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
583 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
584 # Drop the leading ru_, capitalize the next character.
585 field=`echo $field | sed -e 's/^ru_//'`
586 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
587 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
588 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
589 # Fix _timeval _timespec, and _timestruc_t.
590 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
591 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
592 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
593 field="$f$r"
594 nrusage="$nrusage $field;"
595 done
596 echo "type Rusage struct {$nrusage }" >> ${OUT}
597 else
598 echo "type Rusage struct {}" >> ${OUT}
601 # The RUSAGE constants.
602 grep '^const _RUSAGE_' gen-sysinfo.go | \
603 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
605 # The utsname struct.
606 grep '^type _utsname ' gen-sysinfo.go | \
607 sed -e 's/_utsname/Utsname/' \
608 -e 's/sysname/Sysname/' \
609 -e 's/nodename/Nodename/' \
610 -e 's/release/Release/' \
611 -e 's/version/Version/' \
612 -e 's/machine/Machine/' \
613 -e 's/domainname/Domainname/' \
614 >> ${OUT}
616 # The iovec struct.
617 iovec=`grep '^type _iovec ' gen-sysinfo.go`
618 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
619 echo "type Iovec_len_t $iovec_len" >> ${OUT}
620 echo $iovec | \
621 sed -e 's/_iovec/Iovec/' \
622 -e 's/iov_base/Base/' \
623 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
624 >> ${OUT}
626 # The msghdr struct.
627 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
628 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
629 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
630 echo $msghdr | \
631 sed -e 's/_msghdr/Msghdr/' \
632 -e 's/msg_name/Name/' \
633 -e 's/msg_namelen/Namelen/' \
634 -e 's/msg_iov/Iov/' \
635 -e 's/msg_iovlen/Iovlen/' \
636 -e 's/_iovec/Iovec/' \
637 -e 's/msg_control/Control/' \
638 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
639 -e 's/msg_flags/Flags/' \
640 >> ${OUT}
642 # The MSG_ flags for Msghdr.
643 grep '^const _MSG_' gen-sysinfo.go | \
644 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
646 # The cmsghdr struct.
647 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
648 if test -n "$cmsghdr"; then
649 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
650 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
651 echo "$cmsghdr" | \
652 sed -e 's/_cmsghdr/Cmsghdr/' \
653 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
654 -e 's/cmsg_level/Level/' \
655 -e 's/cmsg_type/Type/' \
656 -e 's/\[\]/[0]/' \
657 >> ${OUT}
660 # The SCM_ flags for Cmsghdr.
661 grep '^const _SCM_' gen-sysinfo.go | \
662 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
664 # The ucred struct.
665 grep '^type _ucred ' gen-sysinfo.go | \
666 sed -e 's/_ucred/Ucred/' \
667 -e 's/pid/Pid/' \
668 -e 's/uid/Uid/' \
669 -e 's/gid/Gid/' \
670 >> ${OUT}
672 # The ip_mreq struct.
673 grep '^type _ip_mreq ' gen-sysinfo.go | \
674 sed -e 's/_ip_mreq/IPMreq/' \
675 -e 's/imr_multiaddr/Multiaddr/' \
676 -e 's/imr_interface/Interface/' \
677 -e 's/_in_addr/[4]byte/g' \
678 >> ${OUT}
680 # We need IPMreq to compile the net package.
681 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
682 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
685 # The ipv6_mreq struct.
686 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
687 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
688 -e 's/ipv6mr_multiaddr/Multiaddr/' \
689 -e 's/ipv6mr_interface/Interface/' \
690 -e 's/_in6_addr/[16]byte/' \
691 >> ${OUT}
693 # We need IPv6Mreq to compile the net package.
694 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
695 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
698 # The ip_mreqn struct.
699 grep '^type _ip_mreqn ' gen-sysinfo.go | \
700 sed -e 's/_ip_mreqn/IPMreqn/' \
701 -e 's/imr_multiaddr/Multiaddr/' \
702 -e 's/imr_address/Address/' \
703 -e 's/imr_ifindex/Ifindex/' \
704 -e 's/_in_addr/[4]byte/g' \
705 >> ${OUT}
707 # We need IPMreq to compile the net package.
708 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
709 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
712 # Try to guess the type to use for fd_set.
713 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
714 fds_bits_type="_C_long"
715 if test "$fd_set" != ""; then
716 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
718 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
720 # The addrinfo struct.
721 grep '^type _addrinfo ' gen-sysinfo.go | \
722 sed -e 's/_addrinfo/Addrinfo/g' \
723 -e 's/ ai_/ Ai_/g' \
724 >> ${OUT}
726 # The addrinfo flags and errors.
727 grep '^const _AI_' gen-sysinfo.go | \
728 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
729 grep '^const _EAI_' gen-sysinfo.go | \
730 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
732 # The passwd struct.
733 grep '^type _passwd ' gen-sysinfo.go | \
734 sed -e 's/_passwd/Passwd/' \
735 -e 's/ pw_/ Pw_/g' \
736 >> ${OUT}
738 # The ioctl flags for the controlling TTY.
739 grep '^const _TIOC' gen-sysinfo.go | \
740 grep -v '_val =' | \
741 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
742 # We need TIOCGWINSZ.
743 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
744 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
745 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
748 if ! grep '^const TIOCNOTTY' ${OUT} >/dev/null 2>&1; then
749 if grep '^const _TIOCNOTTY_val' ${OUT} >/dev/null 2>&1; then
750 echo 'const TIOCNOTTY = _TIOCNOTTY_val' >> ${OUT}
753 if ! grep '^const TIOCSCTTY' ${OUT} >/dev/null 2>&1; then
754 if grep '^const _TIOCSCTTY_val' ${OUT} >/dev/null 2>&1; then
755 echo 'const TIOCSCTTY = _TIOCSCTTY_val' >> ${OUT}
759 # The ioctl flags for terminal control
760 grep '^const _TC[GS]ET' gen-sysinfo.go | \
761 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
763 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
764 # needs handling in syscalls.exec.go.
765 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
766 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
767 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
771 # The nlmsghdr struct.
772 grep '^type _nlmsghdr ' gen-sysinfo.go | \
773 sed -e 's/_nlmsghdr/NlMsghdr/' \
774 -e 's/nlmsg_len/Len/' \
775 -e 's/nlmsg_type/Type/' \
776 -e 's/nlmsg_flags/Flags/' \
777 -e 's/nlmsg_seq/Seq/' \
778 -e 's/nlmsg_pid/Pid/' \
779 >> ${OUT}
781 # The nlmsg flags and operators.
782 grep '^const _NLM' gen-sysinfo.go | \
783 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
785 # NLMSG_HDRLEN is defined as an expression using sizeof.
786 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
787 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
788 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
792 # The rtmsg struct.
793 grep '^type _rtmsg ' gen-sysinfo.go | \
794 sed -e 's/_rtmsg/RtMsg/' \
795 -e 's/rtm_family/Family/' \
796 -e 's/rtm_dst_len/Dst_len/' \
797 -e 's/rtm_src_len/Src_len/' \
798 -e 's/rtm_tos/Tos/' \
799 -e 's/rtm_table/Table/' \
800 -e 's/rtm_protocol/Protocol/' \
801 -e 's/rtm_scope/Scope/' \
802 -e 's/rtm_type/Type/' \
803 -e 's/rtm_flags/Flags/' \
804 >> ${OUT}
806 # The rtgenmsg struct.
807 grep '^type _rtgenmsg ' gen-sysinfo.go | \
808 sed -e 's/_rtgenmsg/RtGenmsg/' \
809 -e 's/rtgen_family/Family/' \
810 >> ${OUT}
812 # The routing message flags.
813 grep '^const _RT_' gen-sysinfo.go | \
814 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
815 grep '^const _RTA' gen-sysinfo.go | \
816 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
817 grep '^const _RTF' gen-sysinfo.go | \
818 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
819 grep '^const _RTCF' gen-sysinfo.go | \
820 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
821 grep '^const _RTM' gen-sysinfo.go | \
822 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
823 grep '^const _RTN' gen-sysinfo.go | \
824 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
825 grep '^const _RTPROT' gen-sysinfo.go | \
826 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
828 # The ifinfomsg struct.
829 grep '^type _ifinfomsg ' gen-sysinfo.go | \
830 sed -e 's/_ifinfomsg/IfInfomsg/' \
831 -e 's/ifi_family/Family/' \
832 -e 's/ifi_type/Type/' \
833 -e 's/ifi_index/Index/' \
834 -e 's/ifi_flags/Flags/' \
835 -e 's/ifi_change/Change/' \
836 >> ${OUT}
838 # The interface information types and flags.
839 grep '^const _IFA' gen-sysinfo.go | \
840 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
841 grep '^const _IFLA' gen-sysinfo.go | \
842 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
843 grep '^const _IFF' gen-sysinfo.go | \
844 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
845 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
846 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
847 grep '^const _SIOC' gen-sysinfo.go |
848 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
850 # The ifaddrmsg struct.
851 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
852 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
853 -e 's/ifa_family/Family/' \
854 -e 's/ifa_prefixlen/Prefixlen/' \
855 -e 's/ifa_flags/Flags/' \
856 -e 's/ifa_scope/Scope/' \
857 -e 's/ifa_index/Index/' \
858 >> ${OUT}
860 # The rtattr struct.
861 grep '^type _rtattr ' gen-sysinfo.go | \
862 sed -e 's/_rtattr/RtAttr/' \
863 -e 's/rta_len/Len/' \
864 -e 's/rta_type/Type/' \
865 >> ${OUT}
867 # The in_pktinfo struct.
868 grep '^type _in_pktinfo ' gen-sysinfo.go | \
869 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
870 -e 's/ipi_ifindex/Ifindex/' \
871 -e 's/ipi_spec_dst/Spec_dst/' \
872 -e 's/ipi_addr/Addr/' \
873 -e 's/_in_addr/[4]byte/g' \
874 >> ${OUT}
876 # The in6_pktinfo struct.
877 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
878 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
879 -e 's/ipi6_addr/Addr/' \
880 -e 's/ipi6_ifindex/Ifindex/' \
881 -e 's/_in6_addr/[16]byte/' \
882 >> ${OUT}
884 # The termios struct.
885 grep '^type _termios ' gen-sysinfo.go | \
886 sed -e 's/_termios/Termios/' \
887 -e 's/c_iflag/Iflag/' \
888 -e 's/c_oflag/Oflag/' \
889 -e 's/c_cflag/Cflag/' \
890 -e 's/c_lflag/Lflag/' \
891 -e 's/c_line/Line/' \
892 -e 's/c_cc/Cc/' \
893 -e 's/c_ispeed/Ispeed/' \
894 -e 's/c_ospeed/Ospeed/' \
895 >> ${OUT}
897 # The termios constants.
898 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
899 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
900 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
901 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
902 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
903 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
904 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
905 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
906 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
907 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
908 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
909 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
911 grep "^const _$n " gen-sysinfo.go | \
912 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
913 done
915 # The mount flags
916 grep '^const _MNT_' gen-sysinfo.go |
917 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
918 grep '^const _MS_' gen-sysinfo.go |
919 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
921 # The fallocate flags.
922 grep '^const _FALLOC_' gen-sysinfo.go |
923 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
925 # The statfs struct.
926 # Prefer largefile variant if available.
927 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
928 if test "$statfs" != ""; then
929 grep '^type _statfs64 ' gen-sysinfo.go
930 else
931 grep '^type _statfs ' gen-sysinfo.go
932 fi | sed -e 's/type _statfs64/type Statfs_t/' \
933 -e 's/type _statfs/type Statfs_t/' \
934 -e 's/f_type/Type/' \
935 -e 's/f_bsize/Bsize/' \
936 -e 's/f_blocks/Blocks/' \
937 -e 's/f_bfree/Bfree/' \
938 -e 's/f_bavail/Bavail/' \
939 -e 's/f_files/Files/' \
940 -e 's/f_ffree/Ffree/' \
941 -e 's/f_fsid/Fsid/' \
942 -e 's/f_namelen/Namelen/' \
943 -e 's/f_frsize/Frsize/' \
944 -e 's/f_flags/Flags/' \
945 -e 's/f_spare/Spare/' \
946 >> ${OUT}
948 # The timex struct.
949 timex=`grep '^type _timex ' gen-sysinfo.go || true`
950 if test "$timex" = ""; then
951 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
952 if test "$timex" != ""; then
953 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
956 if test "$timex" != ""; then
957 echo "$timex" | \
958 sed -e 's/_timex/Timex/' \
959 -e 's/modes/Modes/' \
960 -e 's/offset/Offset/' \
961 -e 's/freq/Freq/' \
962 -e 's/maxerror/Maxerror/' \
963 -e 's/esterror/Esterror/' \
964 -e 's/status/Status/' \
965 -e 's/constant/Constant/' \
966 -e 's/precision/Precision/' \
967 -e 's/tolerance/Tolerance/' \
968 -e 's/ time / Time /' \
969 -e 's/tick/Tick/' \
970 -e 's/ppsfreq/Ppsfreq/' \
971 -e 's/jitter/Jitter/' \
972 -e 's/shift/Shift/' \
973 -e 's/stabil/Stabil/' \
974 -e 's/jitcnt/Jitcnt/' \
975 -e 's/calcnt/Calcnt/' \
976 -e 's/errcnt/Errcnt/' \
977 -e 's/stbcnt/Stbcnt/' \
978 -e 's/tai/Tai/' \
979 -e 's/_timeval/Timeval/' \
980 >> ${OUT}
983 # The rlimit struct.
984 grep '^type _rlimit ' gen-sysinfo.go | \
985 sed -e 's/_rlimit/Rlimit/' \
986 -e 's/rlim_cur/Cur/' \
987 -e 's/rlim_max/Max/' \
988 >> ${OUT}
990 # The RLIMIT constants.
991 grep '^const _RLIMIT_' gen-sysinfo.go |
992 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
993 grep '^const _RLIM_' gen-sysinfo.go |
994 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
996 # The sysinfo struct.
997 grep '^type _sysinfo ' gen-sysinfo.go | \
998 sed -e 's/_sysinfo/Sysinfo_t/' \
999 -e 's/uptime/Uptime/' \
1000 -e 's/loads/Loads/' \
1001 -e 's/totalram/Totalram/' \
1002 -e 's/freeram/Freeram/' \
1003 -e 's/sharedram/Sharedram/' \
1004 -e 's/bufferram/Bufferram/' \
1005 -e 's/totalswap/Totalswap/' \
1006 -e 's/freeswap/Freeswap/' \
1007 -e 's/procs/Procs/' \
1008 -e 's/totalhigh/Totalhigh/' \
1009 -e 's/freehigh/Freehigh/' \
1010 -e 's/mem_unit/Unit/' \
1011 >> ${OUT}
1013 # The ustat struct.
1014 grep '^type _ustat ' gen-sysinfo.go | \
1015 sed -e 's/_ustat/Ustat_t/' \
1016 -e 's/f_tfree/Tfree/' \
1017 -e 's/f_tinode/Tinoe/' \
1018 -e 's/f_fname/Fname/' \
1019 -e 's/f_fpack/Fpack/' \
1020 >> ${OUT}
1021 # Force it to be defined, as on some older GNU/Linux systems the
1022 # header file fails when using with <linux/filter.h>.
1023 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
1024 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
1027 # The utimbuf struct.
1028 grep '^type _utimbuf ' gen-sysinfo.go | \
1029 sed -e 's/_utimbuf/Utimbuf/' \
1030 -e 's/actime/Actime/' \
1031 -e 's/modtime/Modtime/' \
1032 >> ${OUT}
1034 # The LOCK flags for flock.
1035 grep '^const _LOCK_' gen-sysinfo.go |
1036 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1038 # The GNU/Linux LINUX_REBOOT flags.
1039 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
1040 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1042 # The GNU/Linux sock_filter struct.
1043 grep '^type _sock_filter ' gen-sysinfo.go | \
1044 sed -e 's/_sock_filter/SockFilter/' \
1045 -e 's/code/Code/' \
1046 -e 's/jt/Jt/' \
1047 -e 's/jf/Jf/' \
1048 -e 's/k /K /' \
1049 >> ${OUT}
1051 # The GNU/Linux sock_fprog struct.
1052 grep '^type _sock_fprog ' gen-sysinfo.go | \
1053 sed -e 's/_sock_fprog/SockFprog/' \
1054 -e 's/len/Len/' \
1055 -e 's/filter/Filter/' \
1056 -e 's/_sock_filter/SockFilter/' \
1057 >> ${OUT}
1059 # The GNU/Linux filter flags.
1060 grep '^const _BPF_' gen-sysinfo.go | \
1061 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1063 # The GNU/Linux nlattr struct.
1064 grep '^type _nlattr ' gen-sysinfo.go | \
1065 sed -e 's/_nlattr/NlAttr/' \
1066 -e 's/nla_len/Len/' \
1067 -e 's/nla_type/Type/' \
1068 >> ${OUT}
1070 # The GNU/Linux nlmsgerr struct.
1071 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1072 sed -e 's/_nlmsgerr/NlMsgerr/' \
1073 -e 's/error/Error/' \
1074 -e 's/msg/Msg/' \
1075 -e 's/_nlmsghdr/NlMsghdr/' \
1076 >> ${OUT}
1078 # The GNU/Linux rtnexthop struct.
1079 grep '^type _rtnexthop ' gen-sysinfo.go | \
1080 sed -e 's/_rtnexthop/RtNexthop/' \
1081 -e 's/rtnh_len/Len/' \
1082 -e 's/rtnh_flags/Flags/' \
1083 -e 's/rtnh_hops/Hops/' \
1084 -e 's/rtnh_ifindex/Ifindex/' \
1085 >> ${OUT}
1087 # The GNU/Linux netlink flags.
1088 grep '^const _NETLINK_' gen-sysinfo.go | \
1089 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1090 grep '^const _NLA_' gen-sysinfo.go | \
1091 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1093 # The GNU/Linux packet socket flags.
1094 grep '^const _PACKET_' gen-sysinfo.go | \
1095 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1097 # The GNU/Linux inotify_event struct.
1098 grep '^type _inotify_event ' gen-sysinfo.go | \
1099 sed -e 's/_inotify_event/InotifyEvent/' \
1100 -e 's/wd/Wd/' \
1101 -e 's/mask/Mask/' \
1102 -e 's/cookie/Cookie/' \
1103 -e 's/len/Len/' \
1104 -e 's/name/Name/' \
1105 -e 's/\[\]/[0]/' \
1106 -e 's/\[0\]byte/[0]int8/' \
1107 >> ${OUT}
1109 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1110 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1111 sed -e 's/_in6_addr/[16]byte/' \
1112 >> ${OUT}
1114 # Struct sizes.
1115 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1116 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1117 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1118 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1119 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1120 sock_filter SockFilter sock_fprog SockFprog ucred Ucred
1121 while test $# != 0; do
1122 nc=$1
1123 ngo=$2
1124 shift
1125 shift
1126 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1127 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1129 done
1131 # In order to compile the net package, we need some sizes to exist
1132 # even if the types do not.
1133 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1134 echo 'const SizeofIPMreq = 8' >> ${OUT}
1136 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1137 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1139 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1140 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1143 exit $?